<template>
  <div style="overflow: hidden;">
    <div class="example-3d">
      <client-only>
        <swiper
          ref="carousel"
          class="swiper"
          :options="swiperOptions"
          @ready="onSwiperRedied"
          @clickSlide="onSwiperClickSlide"
          @slideChangeTransitionStart="onSwiperSlideChangeTransitionStart"
        >
          <swiper-slide v-for="(img, idx) in images" :key="idx">
              <img class="image" :src="img.url" alt="" />
              <p class="label">{{ img.label }}</p>
          </swiper-slide>
        </swiper>
      </client-only>
    </div>
  </div>
</template>

<script>
export default {
  name: "swiper-nuxt",
  props: {
    images: {}
  },
  data() {
    return {
      swiperOptions: {
        effect: "coverflow",
        grabCursor: true,
        centeredSlides: true,
        slidesPerView: "auto",
        coverflowEffect: {
          rotate: 50,
          stretch: 0,
          depth: 100,
          modifier: 1,
          slideShadows: true
        },
        keyboard: {
          enabled: true,
          onlyInViewport: false,
        },
        pagination: {
          // el: ".swiper-pagination"
        }
      }
    };
  },
  methods: {
    onSwiperRedied(swiper) {
      console.log("Swiper rendered!", swiper);
    },
    onSwiperSlideChangeTransitionStart() {
      console.log("SwiperSlideChangeTransitionStart!");
    },
    onSwiperClickSlide(index, reallyIndex) {
      console.log("Swiper click slide!", reallyIndex);
    }
  }
};
</script>

<style lang="scss" scoped>
.example-3d {
  width: 100%;
  height: 400px;
  padding-top: 50px;
  padding-bottom: 50px;
}
.swiper {
  height: 100%;
  width: 100%;
  .swiper-slide {
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    width: 270px;
    height: 100%;
    text-align: center;
    font-weight: bold;
    font-size: 36px;
    // background-color: #2c8dfb;
    background-position: center;
    background-size: cover;
    color: white;
    @media (max-width: 550px) {
      width: 140px;
      height: 140px;
    }
    & img {
      width: 300px;
      @media (max-width: 550px) {
        width: 150px;
      }
    }
  }
  .swiper-pagination {
    ::v-deep .swiper-pagination-bullet.swiper-pagination-bullet-active {
      background-color: transparent;
    }
  }
}

.label {
  color: rgb(50, 128, 240);
  font-size: 16px;
  font-weight: 600;
  @media (max-width: 550px) {
      font-size: 14px;
    }
}
</style>
